from RegexValidator import RegexValidator
from RangeValidator import RangeValidator

baseValidators = [
    RangeValidator('inNumericRange', title='', description=''),
    RegexValidator('isDecimal',
                   r'^([+-]?)(?=\d|\.\d)\d*(\.\d*)?([Ee]([+-]?\d+))?$',
                   title='', description=''),
    RegexValidator('isInt', r'^([+-])?\d+$', title='', description=''),
    RegexValidator('isPrintable', r'[a-zA-Z0-9\s]+$', title='', description=''),
    RegexValidator('isSSN', r'^\d{9}$', title='', description=''),
    RegexValidator('isUSPhoneNumber', r'^\d{10}$', ignore='[\(\)\-\s]',
                   title='', description=''),
    RegexValidator('isInternationalPhoneNumber', r'^\d+$', ignore='[\(\)\-\s\+]',
                   title='', description=''),
    RegexValidator('isZipCode', r'^(\d{5}|\d{9})$',
                   title='', description=''),
    RegexValidator('isURL', r'(ht|f)tps?://[^\s\r\n]+',
                   title='', description=''),
    RegexValidator('isEmail', "^([0-9a-zA-Z_&.+-]+!)*[0-9a-zA-Z_&.+-]+@(([0-9a-z]([0-9a-z-]*[0-9a-z])?\.)+[a-z]{2,6}|([0-9]{1,3}\.){3}[0-9]{1,3})$",
                   title='', description=''),
    ]

__all__ = ('baseValidators', )
