try:
    from Products.validation.interfaces.IValidator import IValidator
except ImportError:
    import sys, os
    sys.path.insert(0, os.path.join(os.path.dirname(__file__), os.pardir))
    from interfaces.IValidator import IValidator
    del sys, os

class EmptyValidator:
    __implements__ = IValidator

    def __init__(self, name, title='', description=''):
        self.name = name
        self.title = title or name
        self.description = description

    def __call__(self, value, *args, **kwargs):
        isEmpty = kwargs.get('isEmpty', None)
        if isEmpty:
            return 1
        elif value == '' or value is None:
            return 1
        else:
            return ("Validation Failed(%s): value '%s' isn't empty or marked as empty" %
                   (self.name, value))

validatorList = [
    EmptyValidator('isEmpty', title='', description=''),
    ]

__all__ = ('validatorList', )

